#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_NoviceGunLiftCFG.h"
std::auto_ptr<M_NoviceGunLiftCFG> M_NoviceGunLiftCFG::msSingleton(nullptr);

int M_NoviceGunLiftCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_NoviceGunLiftCFGData* M_NoviceGunLiftCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_NoviceGunLiftCFGData>& M_NoviceGunLiftCFG::GetMapData()
{
	return mMapData;
}

void M_NoviceGunLiftCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_NoviceGunLiftCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_NoviceGunLiftCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mName = element->Attribute("Name");
		data.mRechangId = element->IntAttribute("RechangId");
		data.mRise = element->IntAttribute("Rise");
		data.mGiftId = element->IntAttribute("GiftId");
		{
			const char* UpgradeNumber = element->Attribute("UpgradeNumber");
			std::vector<std::string> vecUpgradeNumber;
			boost::split(vecUpgradeNumber, UpgradeNumber, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecUpgradeNumber.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecUpgradeNumber[i].c_str(), &temp))
				{
					data.mUpgradeNumber.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_NoviceGunLiftCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NoviceGunLiftCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_NoviceGunLiftCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_NoviceGunLiftCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_NoviceGunLiftCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Name", data.mName);
		LuaCfgHelper::readInt(L, "RechangId", data.mRechangId);
		LuaCfgHelper::readInt(L, "Rise", data.mRise);
		LuaCfgHelper::readInt(L, "GiftId", data.mGiftId);
		LuaCfgHelper::readVectorInt(L, "UpgradeNumber", data.mUpgradeNumber);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_NoviceGunLiftCFG Loaded. Load Data:%u", mMapData.size());
}

void M_NoviceGunLiftCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_NoviceGunLiftCFG* M_NoviceGunLiftCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_NoviceGunLiftCFG());
	}
	return msSingleton.get();
}

void M_NoviceGunLiftCFG::Release()
{
	msSingleton.reset(nullptr);
}
